#!/bin/bash

DIR=`pwd`
echo " Preparing enviroment for  dnl_softswitch installation"
#yum -y install epel-release
#yum -y install https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el6.noarch.rpm
#yum -y install https://download.postgresql.org/pub/repos/yum/9.6/redhat/rhel-7-x86_64/pgdg-centos96-9.6-3.noarch.rpm
#yum clean expire-cache
#yum -y install libnetfilter_conntrack postgresql96 postgresql96-devel wget lzma openssl-devel xz-devel gcc libjpeg-turbo-devel ntp python-devel tcpdump wireshark make bzip2-devel sqlite-devel zip expect telnet git ntp
# this is for when database is also on same server ---
#yum -y install postgresql96-server prefix96 ip4r96 postgresql96-contrib
#---------------------------------------------------------------------#
# install php and prerequisites for web ui
#ln -s /usr/pgsql-9.6/bin/pg_config /usr/bin/pg_config
#ln -s /usr/pgsql-9.6/bin/psql /usr/bin/psql

if [ ! -f /usr/bin/wget ]; then
yum -y install wget 
fi
if [ ! -f /usr/local/bin/python3 ];then
echo " Installing Python3"
cd /usr/local/src/
wget https://www.python.org/ftp/python/3.5.4/Python-3.5.4.tar.xz
tar xf Python-3.5.4.tar.xz
cd Python-3.5.4
./configure
make
make install
#/usr/local/bin/pip3 install psycopg2
#/usr/local/bin/pip3 install --upgrade pip
#/usr/local/bin/pip3 install configparser
#/usr/local/bin/pip3 install flask
#/usr/local/bin/pip3 install Flask-WTF
#/usr/local/bin/pip3 install requests
#/usr/local/bin/pip3 install pillow
#/usr/local/bin/pip3 install reportlab
#/usr/local/bin/pip3 install python-dateutil
#/usr/local/bin/pip3 install lockfile
#/usr/local/bin/pip3 install phpserialize
#/usr/local/bin/pip3 install xlrd pytz psutil
ln -s /usr/local/bin/python3 /usr/bin/python3
rm -r /usr/local/src/Python-3.5.4
echo " done setting python3 "
fi
#/usr/bin/pip install gunicorn flask gcs_client 
#/usr/bin/pip install -U certifi==2015.4.28
mv /etc/localtime /etc/localtime.bak
ln -s /usr/share/zoneinfo/GMT /etc/localtime
echo "enabling and starting network time services"
systemctl start ntpd
systemctl enable ntpd
echo " enter user for which softswitch will be installed to"
read user
id -u $user &>/dev/null|| useradd $user -d /opt/$user
chmod 755 /opt/$user
if [ ! -d /opt/$user ]; then
mkdir /opt/$user
chmod 755 /opt/$user
chown -R $user:$user /opt/$user
fi
echo " User is : $user"
echo "enter password for accessing stash.denovolab.com:"
read -s password
pass=$password
#sleep 3
cd /opt

/usr/bin/expect <<EOD
set timeout 120
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/af/falcon_rest.git /opt/$user/falcon_rest
"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout 120
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/webbackend.git /opt/$user/webbackend"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout 120
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/jswebui.git /opt/$user/jswebui"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
#/usr/bin/expect <<EOD
#set timeout 120
#spawn bash -c "git clone http://meda@stash.denovolab.com/scm/pu/pcap-and-cdr-archive-and-retrival---dennis.git /opt/$user/pcap2_sour"
#expect "Password for 'http://meda@stash.denovolab.com':"
#send $pass\r
#expect eof
#EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas4-v5-rel/class4-v5.0.git /opt/class4-v5-rel"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
#/usr/bin/expect <<EOD
#set timeout 120
#spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas4-v5-rel/database.git /opt/database"
#expect "Password for 'http://meda@stash.denovolab.com':"
#send $pass\r
#expect eof
#EOD
#mkdir /opt/$user/pcap2
#cp /opt/$user/pcap2_sour/cdr_pcap_storage/* /opt/$user/pcap2
cd /opt/class4-v5-rel
if [ ! -d /opt/$user/web ]; then
mkdir /opt/$user/web
fi
#cp -R web /opt/$user/web/
#cp -R etc /opt/$user/web/
#cp -R download /opt/$user/web/
#cp -R script /opt/$user/web/
cp -R backend/dnl_db_writer /opt/$user/
cp -R backend/dnl_livecall /opt/$user/
cp -R backend/dnl_memdb /opt/$user/
#cp -R backend/dnl_sip_proxy /opt/$user/
cp -R backend/dnl_softswitch /opt/$user
cp -R backend/dnl_tools /opt/$user
cp -R backend/dnl_web_helper /opt/$user
cd $DIR
#cp -R postgresql.service /etc/systemd/system/
#systemctl daemon-reload
#echo "Setting up database server"
#/usr/pgsql-9.6/bin/postgresql96-setup initdb postgresql
#systemctl enable postgresql
#systemctl start postgresql
cd /opt/$user/webbackend
#sed -i -e 's/peer/trust/g' /opt/pgsql/9.6/data/pg_hba.conf
#sed -i -e 's/ident/trust/g' /opt/pgsql/9.6/data/pg_hba.conf
#sed 's/peer/trust/g' /opt/pgsql/9.6/data/pg_hba.conf > /opt/pgsql/9.6/data/pg_hba.new
#sed 's/ident/trust/g' /opt/pgsql/9.6/data/pg_hba.new > /opt/pgsql/9.6/data/pg_hba.new1
#mv -f /opt/pgsql/9.6/data/pg_hba.new1 /opt/pgsql/9.6/data/pg_hba.conf
#rm -f /opt/pgsql/9.6/data/pg_hba.new
#systemctl reload postgresql
#systemctl start postgresql
echo "enter database name for the client (default: class4_dnl)"
read database
psql -U postgres -c "create database $database;"
psql -U postgres -c "create user webbackend login superuser password 'shoh6Chahx0Gu9fe';"
psql -U postgres $database < schema/schema.sql
psql -U postgres $database < schema/data.sql
#psql -U postgres $database < code.sql
#psql -U postgres $database < jurisdiction_code.sql
#psql -U postgres $database < update.sql
cd $DIR
cp -R dnl_rt_index /opt/$user/
mkdir /opt/$user/dnl_data_import/logs
mkdir /opt/$user/dnl_monitoring/logs
chown -R $user:$user /opt/$user
#cd /opt/$user/web/web
#/opt/$user/web/web/chmod.sh
echo "Setting ip_forward and iptables for the proxy media"
echo "net.ipv4.ip_forward = 1" >> /etc/sysctl.conf
sysctl -p /etc/sysctl.conf 
modprobe nf_conntrack 
cd $DIR
echo "installing service files "
chown -R root:root denovo_systemd_init_scripts
chmod 644 ./denovo_systemd_init_scripts/sudoers.d/denovo
cp -R denovo_systemd_init_scripts/*.service /etc/systemd/system
systemctl daemon-reload
############################## Softswitch part services  ###############################################################
#systemctl enable dnl_livecall.service dnl_pcap_gunicorn.service dnl_pcap_loader.service dnl_pcap_parser.service dnl_rt_index.service dnl_softswitch.service dnl_tools.service
############# Web Part Services ###########################################################
#systemctl enable  dnl_alerts.service dnl_data_import.service dnl_did_billing.service dnl_invoice_server.service dnl_monitoring.service dnl_webhelper.service dnl_alert_rules.service dnl_fraud.service
##############   All Services #######################
#systemctl enable  dnl_alerts.service dnl_data_import.service dnl_did_billing.service dnl_invoice_server.service dnl_livecall.service dnl_monitoring.service dnl_pcap_gunicorn.service dnl_pcap_loader.service dnl_pcap_parser.service dnl_rt_index.service dnl_softswitch.service dnl_tools.service dnl_webhelper.service dnl_alert_rules.service dnl_fraud.service

#systemctl start  dnl_alerts.service dnl_data_import.service dnl_did_billing.service dnl_invoice_server.service dnl_livecall.service dnl_monitoring.service dnl_pcap_gunicorn.service dnl_pcap_loader.service dnl_pcap_parser.service dnl_rt_index.service dnl_softswitch.service dnl_tools.service dnl_webhelper.service

#echo "preparing httpd for a webUI"
#cp -R /opt/denovo/web/etc/denovo.conf /etc/httpd/conf.d/
#cd $DIR
#chown -R root:root php.ini
#cp -R php.ini /etc/php.ini
#systemctl enable httpd
#systemctl start httpd
echo " Done ! "

