#!/bin/bash -x

cd /opt/denovo_v6/install/webbackend
command=$(git pull)
if [ "$command" == "Already up-to-date." ]; then
echo "No new api updates"
else
#git pull 
pip3 install -r requirements.txt
pip3 install  dist/api-dnl-head.tar.gz
cd /opt/denovo_v6/api_dnl
systemctl stop dnl_api_dnl
/usr/local/bin/alembic -c alembic.ini upgrade head
systemctl start dnl_api_dnl
fi
cd /opt/denovo_v6/install/jswebui/
echo " $(date) hourly updating UI ... "
if [ -f /opt/denovo_v6/install/jswebui/package-lock.json ];then
rm -rf /opt/denovo_v6/install/jswebui/package-lock.json
fi
command2=$(git pull)
if [ "$command2" == "Already up-to-date." ]; then
echo "No new UI updates"
else
mv -f src/config/global.js src/config/global.js-a
#git pull
npm install
cp -r src/config/global.js-a src/config/global.js
npm run build
cp -aR /opt/denovo_v6/install/jswebui/dist/* /opt/denovo_v6/web/
fi
echo " $(date) done "
