#!/bin/bash

#cd /opt/denovo_v6/install/webbackend
#command=$(git pull)
#if [ "$command" == "Already up-to-date." ]; then
#echo "No new api updates"
#else
#git pull 
#pip3 install -r requirements.txt
#pip3 install  dist/api-dnl-head.tar.gz
#cd /opt/denovo_v6/api_dnl
#systemctl stop dnl_api_dnl
#/usr/local/bin/alembic -c alembic.ini upgrade head
#systemctl start dnl_api_dnl
#fi
cd /opt/jswebui/
echo " $(date) hourly updating UI ... "
if [ -f /opt/jswebui/package-lock.json ];then
rm -rf /opt/jswebui/package-lock.json
fi
command2=$(git pull)
if [ "$command2" == "Already up-to-date." ]; then
echo "No new UI updates"
else
#mv -f src/config/global.js src/config/global.js-a
#git pull
npm install
#cp -r src/config/global.js-a src/config/global.js
npm run build
#cp -aR /opt/denovo_v6/install/jswebui/dist/* /opt/denovo_v6/web/
fi
date=$(date)
echo $date
gitversion=$(cat .git/ORIG_HEAD)
echo $gitversion
branch=$(git rev-parse --abbrev-ref HEAD )
commit=$(git show --oneline -s)


echo "
<!DOCTYPE html>
<html>
<body>

<h1> Git build number</h1>
$gitversion

<h1> Git Branch  of this build </h1>

<h2> $branch </h2>

<h1> Git latest commit</h1>
$commit

<h2> Build date </h2>
$date
</body>
</html>
" > /opt/jswebui/dist/version.html
echo " $(date) done "
